Index: trunk/FACT++/gui/FactGui.h
===================================================================
--- trunk/FACT++/gui/FactGui.h	(revision 10524)
+++ trunk/FACT++/gui/FactGui.h	(revision 10528)
@@ -1004,4 +1004,6 @@
             return;
         }
+
+        fPing->setChecked(false);
 
         const FTM::DimFtuList &sdata = *reinterpret_cast<const FTM::DimFtuList*>(d.ptr());
Index: trunk/FACT++/gui/MainWindow.cc
===================================================================
--- trunk/FACT++/gui/MainWindow.cc	(revision 10524)
+++ trunk/FACT++/gui/MainWindow.cc	(revision 10528)
@@ -134,2 +134,8 @@
             cout << "--------------> clicked #" << i << endl;
 }
+
+void MainWindow::on_fPing_toggled(bool checked)
+{
+    if (checked)
+        DimClient::sendCommand("FTM_CONTROL/PING", NULL, 0);
+}
Index: trunk/FACT++/gui/MainWindow.h
===================================================================
--- trunk/FACT++/gui/MainWindow.h	(revision 10524)
+++ trunk/FACT++/gui/MainWindow.h	(revision 10528)
@@ -75,4 +75,5 @@
     // Tab: FTUs
     void slot_fFtuLED_clicked();
+    void on_fPing_toggled(bool);
 
     // Tab: Rates
Index: trunk/FACT++/gui/design.ui
===================================================================
--- trunk/FACT++/gui/design.ui	(revision 10524)
+++ trunk/FACT++/gui/design.ui	(revision 10528)
@@ -10,5 +10,5 @@
     <x>0</x>
     <y>0</y>
-    <width>1024</width>
+    <width>1042</width>
     <height>768</height>
    </rect>
@@ -1709,5 +1709,11 @@
                <size>
                 <width>359</width>
-                <height>176</height>
+                <height>185</height>
+               </size>
+              </property>
+              <property name="maximumSize">
+               <size>
+                <width>359</width>
+                <height>16777215</height>
                </size>
               </property>
@@ -1716,6 +1722,6 @@
               </property>
               <layout class="QGridLayout" name="gridLayout_32">
-               <item row="0" column="0">
-                <layout class="QGridLayout" name="fFtuLedLayout" rowstretch="0,0,0,0,0" columnstretch="0,0,0,0,0,0,0,0,0,0,0,0">
+               <item row="1" column="0" colspan="3">
+                <layout class="QGridLayout" name="fFtuLedLayout" rowstretch="0,1,1,1,1" columnstretch="0,1,1,1,1,1,1,1,1,1,1,0">
                  <property name="margin">
                   <number>4</number>
@@ -1762,5 +1768,5 @@
                   <widget class="QLabel" name="label_42">
                    <property name="text">
-                    <string>Crate#0</string>
+                    <string>Crate #0</string>
                    </property>
                   </widget>
@@ -1776,5 +1782,5 @@
                   <widget class="QLabel" name="label_44">
                    <property name="text">
-                    <string>Crate#2</string>
+                    <string>Crate #2</string>
                    </property>
                   </widget>
@@ -1968,4 +1974,27 @@
                  </item>
                 </layout>
+               </item>
+               <item row="2" column="1">
+                <widget class="QPushButton" name="fPing">
+                 <property name="text">
+                  <string> Ping </string>
+                 </property>
+                 <property name="checkable">
+                  <bool>true</bool>
+                 </property>
+                </widget>
+               </item>
+               <item row="2" column="0">
+                <spacer name="horizontalSpacer_13">
+                 <property name="orientation">
+                  <enum>Qt::Horizontal</enum>
+                 </property>
+                 <property name="sizeHint" stdset="0">
+                  <size>
+                   <width>40</width>
+                   <height>20</height>
+                  </size>
+                 </property>
+                </spacer>
                </item>
               </layout>
@@ -3256,6 +3285,6 @@
 &lt;html&gt;&lt;head&gt;&lt;meta name=&quot;qrichtext&quot; content=&quot;1&quot; /&gt;&lt;style type=&quot;text/css&quot;&gt;
 p, li { white-space: pre-wrap; }
-&lt;/style&gt;&lt;/head&gt;&lt;body style=&quot; font-family:'Ubuntu'; font-size:9pt; font-weight:400; font-style:normal;&quot;&gt;
-&lt;p style=&quot;-qt-paragraph-type:empty; margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;&quot;&gt;&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</string>
+&lt;/style&gt;&lt;/head&gt;&lt;body style=&quot; font-family:'Sans Serif'; font-size:9pt; font-weight:400; font-style:normal;&quot;&gt;
+&lt;p style=&quot;-qt-paragraph-type:empty; margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px; font-family:'Ubuntu';&quot;&gt;&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</string>
               </property>
               <property name="textInteractionFlags">
@@ -3309,5 +3338,5 @@
      <x>0</x>
      <y>0</y>
-     <width>1024</width>
+     <width>1042</width>
      <height>21</height>
     </rect>
@@ -3493,5 +3522,5 @@
    <property name="minimumSize">
     <size>
-     <width>207</width>
+     <width>223</width>
      <height>262</height>
     </size>
@@ -3520,5 +3549,5 @@
      <item>
       <layout class="QGridLayout" name="gridLayout_11">
-       <item row="1" column="5">
+       <item row="1" column="4">
         <widget class="QLabel" name="fStatusDNSLabel">
          <property name="text">
@@ -3527,5 +3556,5 @@
         </widget>
        </item>
-       <item row="1" column="4">
+       <item row="1" column="3">
         <widget class="QPushButton" name="fStatusDNSLed">
          <property name="enabled">
@@ -3565,5 +3594,5 @@
         </widget>
        </item>
-       <item row="3" column="5">
+       <item row="3" column="4">
         <widget class="QLabel" name="fStatusFTMLabel">
          <property name="text">
@@ -3572,5 +3601,5 @@
         </widget>
        </item>
-       <item row="3" column="4">
+       <item row="3" column="3">
         <widget class="QPushButton" name="fStatusFTMLed">
          <property name="enabled">
@@ -3610,5 +3639,5 @@
         </widget>
        </item>
-       <item row="3" column="2">
+       <item row="3" column="1">
         <widget class="QCheckBox" name="fStatusFTMEnable">
          <property name="enabled">
@@ -3635,5 +3664,5 @@
         </widget>
        </item>
-       <item row="4" column="5">
+       <item row="4" column="4">
         <widget class="QLabel" name="fStatusFADLabel">
          <property name="text">
@@ -3642,5 +3671,5 @@
         </widget>
        </item>
-       <item row="4" column="4">
+       <item row="4" column="3">
         <widget class="QPushButton" name="fStatusFADLed">
          <property name="enabled">
@@ -3680,5 +3709,5 @@
         </widget>
        </item>
-       <item row="4" column="2">
+       <item row="4" column="1">
         <widget class="QCheckBox" name="fStatusFADEnable">
          <property name="enabled">
@@ -3705,5 +3734,5 @@
         </widget>
        </item>
-       <item row="6" column="5">
+       <item row="6" column="4">
         <widget class="QLabel" name="fStatusChatLabel">
          <property name="text">
@@ -3712,5 +3741,5 @@
         </widget>
        </item>
-       <item row="6" column="4">
+       <item row="6" column="3">
         <widget class="QPushButton" name="fStatusChatLed">
          <property name="enabled">
@@ -3750,5 +3779,5 @@
         </widget>
        </item>
-       <item row="5" column="2">
+       <item row="5" column="1">
         <widget class="QCheckBox" name="fStatusLoggerEnable">
          <property name="enabled">
@@ -3775,5 +3804,5 @@
         </widget>
        </item>
-       <item row="5" column="4">
+       <item row="5" column="3">
         <widget class="QPushButton" name="fStatusLoggerLed">
          <property name="enabled">
@@ -3813,5 +3842,5 @@
         </widget>
        </item>
-       <item row="5" column="5">
+       <item row="5" column="4">
         <widget class="QLabel" name="fStatusLoggerLabel">
          <property name="text">
@@ -3820,31 +3849,5 @@
         </widget>
        </item>
-       <item row="1" column="0">
-        <spacer name="horizontalSpacer_7">
-         <property name="orientation">
-          <enum>Qt::Horizontal</enum>
-         </property>
-         <property name="sizeHint" stdset="0">
-          <size>
-           <width>40</width>
-           <height>20</height>
-          </size>
-         </property>
-        </spacer>
-       </item>
-       <item row="1" column="6">
-        <spacer name="horizontalSpacer_8">
-         <property name="orientation">
-          <enum>Qt::Horizontal</enum>
-         </property>
-         <property name="sizeHint" stdset="0">
-          <size>
-           <width>40</width>
-           <height>20</height>
-          </size>
-         </property>
-        </spacer>
-       </item>
-       <item row="2" column="0" colspan="7">
+       <item row="2" column="0" colspan="6">
         <widget class="Line" name="line">
          <property name="orientation">
@@ -3853,5 +3856,5 @@
         </widget>
        </item>
-       <item row="3" column="3">
+       <item row="3" column="2">
         <widget class="QLabel" name="fStatusFTM">
          <property name="sizePolicy">
@@ -3872,5 +3875,5 @@
         </widget>
        </item>
-       <item row="4" column="3">
+       <item row="4" column="2">
         <widget class="QLabel" name="fStatusFAD">
          <property name="sizePolicy">
@@ -3891,5 +3894,5 @@
         </widget>
        </item>
-       <item row="5" column="3">
+       <item row="5" column="2">
         <widget class="QLabel" name="fStatusLogger">
          <property name="sizePolicy">
@@ -3910,5 +3913,5 @@
         </widget>
        </item>
-       <item row="6" column="3">
+       <item row="6" column="2">
         <widget class="QLabel" name="fStatusChat">
          <property name="sizePolicy">
@@ -3929,5 +3932,5 @@
         </widget>
        </item>
-       <item row="1" column="3">
+       <item row="1" column="2">
         <widget class="QLabel" name="fStatusDNS">
          <property name="sizePolicy">
@@ -3947,4 +3950,17 @@
          </property>
         </widget>
+       </item>
+       <item row="1" column="5">
+        <spacer name="horizontalSpacer_8">
+         <property name="orientation">
+          <enum>Qt::Horizontal</enum>
+         </property>
+         <property name="sizeHint" stdset="0">
+          <size>
+           <width>40</width>
+           <height>20</height>
+          </size>
+         </property>
+        </spacer>
        </item>
       </layout>