Index: trunk/FACT++/gui/FactGui.h
===================================================================
--- trunk/FACT++/gui/FactGui.h	(revision 10577)
+++ trunk/FACT++/gui/FactGui.h	(revision 10580)
@@ -1210,4 +1210,14 @@
             fChatMessage->setEnabled(fChatOnline);
         }
+
+        if (server=="SCHEDULER")
+        {
+            fStatusSchedulerLabel->setText(s.name.c_str());
+
+            if (s.index>=0) // Dim connection / FTM connected
+                fStatusSchedulerLed->setIcon(QIcon(":/Resources/icons/green circle 1.png"));
+            else
+                fStatusSchedulerLed->setIcon(QIcon(":/Resources/icons/gray circle 1.png"));
+        }
     }
 
@@ -1252,5 +1262,5 @@
 
 
-        out << "<font color='";
+        out << "<font style='font-family:monospace' color='";
 
         switch (qos)
Index: trunk/FACT++/gui/design.ui
===================================================================
--- trunk/FACT++/gui/design.ui	(revision 10577)
+++ trunk/FACT++/gui/design.ui	(revision 10580)
@@ -52,5 +52,5 @@
       </property>
       <property name="currentIndex">
-       <number>0</number>
+       <number>3</number>
       </property>
       <property name="documentMode">
@@ -3584,6 +3584,6 @@
    <property name="minimumSize">
     <size>
-     <width>223</width>
-     <height>291</height>
+     <width>200</width>
+     <height>320</height>
     </size>
    </property>
@@ -3796,5 +3796,5 @@
         </widget>
        </item>
-       <item row="7" column="4">
+       <item row="8" column="4">
         <widget class="QLabel" name="fStatusChatLabel">
          <property name="text">
@@ -3803,5 +3803,5 @@
         </widget>
        </item>
-       <item row="7" column="3">
+       <item row="8" column="3">
         <widget class="QPushButton" name="fStatusChatLed">
          <property name="enabled">
@@ -3841,5 +3841,5 @@
         </widget>
        </item>
-       <item row="6" column="1">
+       <item row="7" column="1">
         <widget class="QCheckBox" name="fStatusLoggerEnable">
          <property name="enabled">
@@ -3866,5 +3866,5 @@
         </widget>
        </item>
-       <item row="6" column="3">
+       <item row="7" column="3">
         <widget class="QPushButton" name="fStatusLoggerLed">
          <property name="enabled">
@@ -3904,5 +3904,5 @@
         </widget>
        </item>
-       <item row="6" column="4">
+       <item row="7" column="4">
         <widget class="QLabel" name="fStatusLoggerLabel">
          <property name="text">
@@ -3956,5 +3956,5 @@
         </widget>
        </item>
-       <item row="6" column="2">
+       <item row="7" column="2">
         <widget class="QLabel" name="fStatusLogger">
          <property name="sizePolicy">
@@ -3975,5 +3975,5 @@
         </widget>
        </item>
-       <item row="7" column="2">
+       <item row="8" column="2">
         <widget class="QLabel" name="fStatusChat">
          <property name="sizePolicy">
@@ -4066,4 +4066,38 @@
          <property name="text">
           <string>Offline</string>
+         </property>
+        </widget>
+       </item>
+       <item row="6" column="2">
+        <widget class="QLabel" name="label_60">
+         <property name="text">
+          <string>Scheduler</string>
+         </property>
+        </widget>
+       </item>
+       <item row="6" column="4">
+        <widget class="QLabel" name="fStatusSchedulerLabel">
+         <property name="text">
+          <string>Offline</string>
+         </property>
+        </widget>
+       </item>
+       <item row="6" column="3">
+        <widget class="QPushButton" name="fStatusSchedulerLed">
+         <property name="maximumSize">
+          <size>
+           <width>18</width>
+           <height>16777215</height>
+          </size>
+         </property>
+         <property name="text">
+          <string/>
+         </property>
+         <property name="icon">
+          <iconset resource="design.qrc">
+           <normaloff>:/Resources/icons/gray circle 1.png</normaloff>:/Resources/icons/gray circle 1.png</iconset>
+         </property>
+         <property name="flat">
+          <bool>true</bool>
          </property>
         </widget>