Index: trunk/FACT++/configure
===================================================================
--- trunk/FACT++/configure	(revision 10682)
+++ trunk/FACT++/configure	(revision 10693)
@@ -751,4 +751,10 @@
 IS_FALSE_FALSE
 IS_FALSE_TRUE
+HAS_FITS_FALSE
+HAS_FITS_TRUE
+HAS_CCFITS_FALSE
+HAS_CCFITS_TRUE
+HAS_CFITSIO_FALSE
+HAS_CFITSIO_TRUE
 HAS_GUI_FALSE
 HAS_GUI_TRUE
@@ -4450,11 +4456,11 @@
   lt_cv_nm_interface="BSD nm"
   echo "int some_variable = 0;" > conftest.$ac_ext
-  (eval echo "\"\$as_me:4452: $ac_compile\"" >&5)
+  (eval echo "\"\$as_me:4458: $ac_compile\"" >&5)
   (eval "$ac_compile" 2>conftest.err)
   cat conftest.err >&5
-  (eval echo "\"\$as_me:4455: $NM \\\"conftest.$ac_objext\\\"\"" >&5)
+  (eval echo "\"\$as_me:4461: $NM \\\"conftest.$ac_objext\\\"\"" >&5)
   (eval "$NM \"conftest.$ac_objext\"" 2>conftest.err > conftest.out)
   cat conftest.err >&5
-  (eval echo "\"\$as_me:4458: output\"" >&5)
+  (eval echo "\"\$as_me:4464: output\"" >&5)
   cat conftest.out >&5
   if $GREP 'External.*some_variable' conftest.out > /dev/null; then
@@ -5662,5 +5668,5 @@
 *-*-irix6*)
   # Find out which ABI we are using.
-  echo '#line 5664 "configure"' > conftest.$ac_ext
+  echo '#line 5670 "configure"' > conftest.$ac_ext
   if { { eval echo "\"\$as_me\":${as_lineno-$LINENO}: \"$ac_compile\""; } >&5
   (eval $ac_compile) 2>&5
@@ -7590,9 +7596,9 @@
    -e 's: [^ ]*conftest\.: $lt_compiler_flag&:; t' \
    -e 's:$: $lt_compiler_flag:'`
-   (eval echo "\"\$as_me:7592: $lt_compile\"" >&5)
+   (eval echo "\"\$as_me:7598: $lt_compile\"" >&5)
    (eval "$lt_compile" 2>conftest.err)
    ac_status=$?
    cat conftest.err >&5
-   echo "$as_me:7596: \$? = $ac_status" >&5
+   echo "$as_me:7602: \$? = $ac_status" >&5
    if (exit $ac_status) && test -s "$ac_outfile"; then
      # The compiler can only warn and ignore the option if not recognized
@@ -7929,9 +7935,9 @@
    -e 's: [^ ]*conftest\.: $lt_compiler_flag&:; t' \
    -e 's:$: $lt_compiler_flag:'`
-   (eval echo "\"\$as_me:7931: $lt_compile\"" >&5)
+   (eval echo "\"\$as_me:7937: $lt_compile\"" >&5)
    (eval "$lt_compile" 2>conftest.err)
    ac_status=$?
    cat conftest.err >&5
-   echo "$as_me:7935: \$? = $ac_status" >&5
+   echo "$as_me:7941: \$? = $ac_status" >&5
    if (exit $ac_status) && test -s "$ac_outfile"; then
      # The compiler can only warn and ignore the option if not recognized
@@ -8034,9 +8040,9 @@
    -e 's: [^ ]*conftest\.: $lt_compiler_flag&:; t' \
    -e 's:$: $lt_compiler_flag:'`
-   (eval echo "\"\$as_me:8036: $lt_compile\"" >&5)
+   (eval echo "\"\$as_me:8042: $lt_compile\"" >&5)
    (eval "$lt_compile" 2>out/conftest.err)
    ac_status=$?
    cat out/conftest.err >&5
-   echo "$as_me:8040: \$? = $ac_status" >&5
+   echo "$as_me:8046: \$? = $ac_status" >&5
    if (exit $ac_status) && test -s out/conftest2.$ac_objext
    then
@@ -8089,9 +8095,9 @@
    -e 's: [^ ]*conftest\.: $lt_compiler_flag&:; t' \
    -e 's:$: $lt_compiler_flag:'`
-   (eval echo "\"\$as_me:8091: $lt_compile\"" >&5)
+   (eval echo "\"\$as_me:8097: $lt_compile\"" >&5)
    (eval "$lt_compile" 2>out/conftest.err)
    ac_status=$?
    cat out/conftest.err >&5
-   echo "$as_me:8095: \$? = $ac_status" >&5
+   echo "$as_me:8101: \$? = $ac_status" >&5
    if (exit $ac_status) && test -s out/conftest2.$ac_objext
    then
@@ -10473,5 +10479,5 @@
   lt_status=$lt_dlunknown
   cat > conftest.$ac_ext <<_LT_EOF
-#line 10475 "configure"
+#line 10481 "configure"
 #include "confdefs.h"
 
@@ -10569,5 +10575,5 @@
   lt_status=$lt_dlunknown
   cat > conftest.$ac_ext <<_LT_EOF
-#line 10571 "configure"
+#line 10577 "configure"
 #include "confdefs.h"
 
@@ -12525,9 +12531,9 @@
    -e 's: [^ ]*conftest\.: $lt_compiler_flag&:; t' \
    -e 's:$: $lt_compiler_flag:'`
-   (eval echo "\"\$as_me:12527: $lt_compile\"" >&5)
+   (eval echo "\"\$as_me:12533: $lt_compile\"" >&5)
    (eval "$lt_compile" 2>conftest.err)
    ac_status=$?
    cat conftest.err >&5
-   echo "$as_me:12531: \$? = $ac_status" >&5
+   echo "$as_me:12537: \$? = $ac_status" >&5
    if (exit $ac_status) && test -s "$ac_outfile"; then
      # The compiler can only warn and ignore the option if not recognized
@@ -12624,9 +12630,9 @@
    -e 's: [^ ]*conftest\.: $lt_compiler_flag&:; t' \
    -e 's:$: $lt_compiler_flag:'`
-   (eval echo "\"\$as_me:12626: $lt_compile\"" >&5)
+   (eval echo "\"\$as_me:12632: $lt_compile\"" >&5)
    (eval "$lt_compile" 2>out/conftest.err)
    ac_status=$?
    cat out/conftest.err >&5
-   echo "$as_me:12630: \$? = $ac_status" >&5
+   echo "$as_me:12636: \$? = $ac_status" >&5
    if (exit $ac_status) && test -s out/conftest2.$ac_objext
    then
@@ -12676,9 +12682,9 @@
    -e 's: [^ ]*conftest\.: $lt_compiler_flag&:; t' \
    -e 's:$: $lt_compiler_flag:'`
-   (eval echo "\"\$as_me:12678: $lt_compile\"" >&5)
+   (eval echo "\"\$as_me:12684: $lt_compile\"" >&5)
    (eval "$lt_compile" 2>out/conftest.err)
    ac_status=$?
    cat out/conftest.err >&5
-   echo "$as_me:12682: \$? = $ac_status" >&5
+   echo "$as_me:12688: \$? = $ac_status" >&5
    if (exit $ac_status) && test -s out/conftest2.$ac_objext
    then
@@ -18236,5 +18242,5 @@
 
 	if test "$no_good" = yes; then
-		as_fn_error $? "cfitsio not properly installed/not found." "$LINENO" 5
+		HAVE_CFITSIO=no
 
 		LIBS=$OLD_LIBS
@@ -18243,5 +18249,5 @@
 		CFLAGS=$OLD_CFLAGS
 	else
-
+		HAVE_CFITSIO=yes
 
 		$as_echo "#define HAVE_PKG_cfitsio 1" >>confdefs.h
@@ -18357,5 +18363,5 @@
 
 	if test "$no_good" = yes; then
-		as_fn_error $? "CCfits not properly installed/not found." "$LINENO" 5
+		HAVE_CCFITS=no
 
 		LIBS=$OLD_LIBS
@@ -18364,5 +18370,5 @@
 		CFLAGS=$OLD_CFLAGS
 	else
-
+		HAVE_CCFITS=yes
 
 		$as_echo "#define HAVE_PKG_ccfits 1" >>confdefs.h
@@ -21609,5 +21615,5 @@
 
 		cat > conftest.$ac_ext <<EOF
-#line 21611 "configure"
+#line 21617 "configure"
 #include "confdefs.h"
 #include <qglobal.h>
@@ -22287,4 +22293,28 @@
 fi
 
+ if test "$HAVE_CFITSIO" = yes; then
+  HAS_CFITSIO_TRUE=
+  HAS_CFITSIO_FALSE='#'
+else
+  HAS_CFITSIO_TRUE='#'
+  HAS_CFITSIO_FALSE=
+fi
+
+ if test "$HAVE_CCFITS" = yes; then
+  HAS_CCFITS_TRUE=
+  HAS_CCFITS_FALSE='#'
+else
+  HAS_CCFITS_TRUE='#'
+  HAS_CCFITS_FALSE=
+fi
+
+ if test "$HAVE_CFITSIO" = yes -a "$HAVE_CCFITS" = yes; then
+  HAS_FITS_TRUE=
+  HAS_FITS_FALSE='#'
+else
+  HAS_FITS_TRUE='#'
+  HAS_FITS_FALSE=
+fi
+
 
  if test "x" = "y"; then
@@ -22304,4 +22334,9 @@
 fi
 
+
+if test "$HAVE_CFITSIO" = yes -a "$HAVE_CCFITS" = yes; then
+  $as_echo "#define HAVE_FITS 1" >>confdefs.h
+
+fi
 
 ##########################################################################
@@ -22601,4 +22636,16 @@
 if test -z "${HAS_GUI_TRUE}" && test -z "${HAS_GUI_FALSE}"; then
   as_fn_error $? "conditional \"HAS_GUI\" was never defined.
+Usually this means the macro was only invoked conditionally." "$LINENO" 5
+fi
+if test -z "${HAS_CFITSIO_TRUE}" && test -z "${HAS_CFITSIO_FALSE}"; then
+  as_fn_error $? "conditional \"HAS_CFITSIO\" was never defined.
+Usually this means the macro was only invoked conditionally." "$LINENO" 5
+fi
+if test -z "${HAS_CCFITS_TRUE}" && test -z "${HAS_CCFITS_FALSE}"; then
+  as_fn_error $? "conditional \"HAS_CCFITS\" was never defined.
+Usually this means the macro was only invoked conditionally." "$LINENO" 5
+fi
+if test -z "${HAS_FITS_TRUE}" && test -z "${HAS_FITS_FALSE}"; then
+  as_fn_error $? "conditional \"HAS_FITS\" was never defined.
 Usually this means the macro was only invoked conditionally." "$LINENO" 5
 fi
@@ -24991,4 +25038,17 @@
 { $as_echo "$as_me:${as_lineno-$LINENO}: " >&5
 $as_echo "$as_me: " >&6;}
+{ $as_echo "$as_me:${as_lineno-$LINENO}:  cfitsio                / 'fitsio.h'        found: $HAVE_CFITSIO" >&5
+$as_echo "$as_me:  cfitsio                / 'fitsio.h'        found: $HAVE_CFITSIO" >&6;}
+{ $as_echo "$as_me:${as_lineno-$LINENO}:  CCfits                 / 'CCfits/CCfits'   found: $HAVE_CCFITS" >&5
+$as_echo "$as_me:  CCfits                 / 'CCfits/CCfits'   found: $HAVE_CCFITS" >&6;}
+if test "$lt_cv_libxp" = "yes"; then
+  { $as_echo "$as_me:${as_lineno-$LINENO}:  Motif/lesstif          / 'Xm/Xm.h' 'libXp' found: yes" >&5
+$as_echo "$as_me:  Motif/lesstif          / 'Xm/Xm.h' 'libXp' found: yes" >&6;}
+else
+  { $as_echo "$as_me:${as_lineno-$LINENO}:  Motif/lesstif          / 'Xm/Xm.h' 'libXp' found: no" >&5
+$as_echo "$as_me:  Motif/lesstif          / 'Xm/Xm.h' 'libXp' found: no" >&6;}
+
+fi
+
 if test "$lt_cv_libxp" = "yes"; then
   { $as_echo "$as_me:${as_lineno-$LINENO}:  Motif/lesstif          / 'Xm/Xm.h' 'libXp' found: yes" >&5
@@ -25145,4 +25205,11 @@
 
 fi
+if test "$HAVE_CFITSIO" = yes -a "$HAVE_CCFITS" = yes; then
+  :
+else
+  { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING:  FITS support disabled. cfitsio/CCfits missing!" >&5
+$as_echo "$as_me: WARNING:  FITS support disabled. cfitsio/CCfits missing!" >&2;}
+
+fi
 if test "$ROOTEXEC" != no; then
   if test "$HAVE_ROOT_QT" = yes; then